# coding: utf-8

"""
    validateapi

    The validation APIs help you validate data. Check if an E-mail address is real. Check if a domain is real. Check up on an IP address, and even where it is located. All this and much more is available in the validation API.  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class SqlInjectionCheckBatchRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'request_items': 'list[SqlInjectionCheckRequestItem]',
        'detection_level': 'str'
    }

    attribute_map = {
        'request_items': 'RequestItems',
        'detection_level': 'DetectionLevel'
    }

    def __init__(self, request_items=None, detection_level=None):  # noqa: E501
        """SqlInjectionCheckBatchRequest - a model defined in Swagger"""  # noqa: E501

        self._request_items = None
        self._detection_level = None
        self.discriminator = None

        if request_items is not None:
            self.request_items = request_items
        if detection_level is not None:
            self.detection_level = detection_level

    @property
    def request_items(self):
        """Gets the request_items of this SqlInjectionCheckBatchRequest.  # noqa: E501

        Multiple items to detect for SQL Injection  # noqa: E501

        :return: The request_items of this SqlInjectionCheckBatchRequest.  # noqa: E501
        :rtype: list[SqlInjectionCheckRequestItem]
        """
        return self._request_items

    @request_items.setter
    def request_items(self, request_items):
        """Sets the request_items of this SqlInjectionCheckBatchRequest.

        Multiple items to detect for SQL Injection  # noqa: E501

        :param request_items: The request_items of this SqlInjectionCheckBatchRequest.  # noqa: E501
        :type: list[SqlInjectionCheckRequestItem]
        """

        self._request_items = request_items

    @property
    def detection_level(self):
        """Gets the detection_level of this SqlInjectionCheckBatchRequest.  # noqa: E501

        Set to Normal to target a high-security SQL Injection detection level with a very low false positive rate; select High to target a very-high security SQL Injection detection level with higher false positives.  Default is Normal (recommended).  # noqa: E501

        :return: The detection_level of this SqlInjectionCheckBatchRequest.  # noqa: E501
        :rtype: str
        """
        return self._detection_level

    @detection_level.setter
    def detection_level(self, detection_level):
        """Sets the detection_level of this SqlInjectionCheckBatchRequest.

        Set to Normal to target a high-security SQL Injection detection level with a very low false positive rate; select High to target a very-high security SQL Injection detection level with higher false positives.  Default is Normal (recommended).  # noqa: E501

        :param detection_level: The detection_level of this SqlInjectionCheckBatchRequest.  # noqa: E501
        :type: str
        """

        self._detection_level = detection_level

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SqlInjectionCheckBatchRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SqlInjectionCheckBatchRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
